#include "MainWnd.h"
#include <qdialog.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qevent.h>

class TestDialog : public QDialog
  {
  public:
    TestDialog(QWidget* aObject) : QDialog(aObject)
      {
      QLabel* label = new QLabel("TEST LABEL cached", this);
      setWindowFlags(this->windowFlags() & ~Qt::WindowContextHelpButtonHint);
      setFixedWidth(400);
      setFixedHeight(400);
      }

    // WORKAROUND
    //void closeEvent(QCloseEvent* bar) override
    //  {
    //  bar->ignore();
    //  hide();
    //  }
  };

MainWnd::MainWnd(QObject* aObject)
  : QObject(aObject)
  {
  theTimer.start(0);
  theTimer.setSingleShot(true);
  connect(&theTimer, &QTimer::timeout, this, &MainWnd::slotTimeout);
  }

void MainWnd::slotTimeout()
  {
  QDialog main;
  TestDialog* cachedDialog = new TestDialog(&main);

  // button - cached dialog
  QPushButton* btn1 = new QPushButton("cached dialog", &main);
  btn1->setGeometry(0, 0, 90, 30);
  connect(btn1, &QPushButton::clicked, [cachedDialog]()
    {
    cachedDialog->exec();
    });

  // button - new dialog
  QPushButton* btn2 = new QPushButton("new dialog", &main);
  btn2->setGeometry(0, 30, 90, 30);
  connect(btn2, &QPushButton::clicked, [&main]()
    {
    TestDialog dialog(&main);
    dialog.exec();
    });

  // main window
  main.exec();
  }